#ifndef CALC_H
#define CALC_H

#include <pebble.h>
#include "pebblisp.h"

#define SMAX_LENGTH 256
#define RESULT_LENGTH 20
#define END_PHRASE "END"

#define NUM_ROWS 5

Window *s_menu_window;
Window *s_code_window;

// Code layers
TextLayer *s_input_text_layer;
TextLayer *s_result_text_layer;

// Menu layers
MenuLayer *s_menu_layer;
TextLayer *s_list_message_layer;

int current_code;

// PebbLisp environment
static struct Environment env;

// Live code text
char mytext[SMAX_LENGTH] = "";

// The actual displayed code text
char temptext[SMAX_LENGTH] = "";

// The result of execution
char resulttext[RESULT_LENGTH] = "";

char *tokens[] = {
    "  ", "(", ")", 
    "+ ", "- ", "* ", "/ ",
    "1","2","3",
    "4","5","6",
    "7","8","9", "0",
    "a", "b", "c", "d", "e", 
    "= ", "< ", "> ", 
    "map", "fn", "def", "if", "\n",
    END_PHRASE
};

void code_window_load(Window *window);
void code_window_unload(Window *window);

#endif
